기본적으로 일부 로깅이 포함된 한 줄짜리 쉘 스크립트가 있고 이를 init 스크립트에서 실행하려고 합니다. Redhat을 사용할 수 없는 것 같아서 daemon
그 안에 있는 기능을 사용하여 실행하고 있습니다 . init 스크립트()를 호출하면 프로세스가 종료되고 실행되는 대신 포그라운드에 유지됩니다. 이 스크립트 데몬을 만드는 올바른 방법은 무엇입니까?/etc/init.d/functions
start-stop-daemon
/etc/init.d/script start
실행할 스크립트:
# conf file where variables are defined
. /etc/script.conf
echo "Starting..." | logger -i
echo "Monitoring $LOG_LOCATION." | logger -i
echo "Sending to $MONITOR_HOST:$MONITOR_PORT." | logger -i
tail -n 1 -F $LOG_LOCATION |
grep WARN --line-buffered |
/usr/bin/nc -vv $MONITOR_HOST $MONITOR_PORT 2>&1 |
logger -i
초기화 스크립트:
#!/bin/bash
# Source Defaults
. /etc/default/script
# Source init functions
. /etc/init.d/functions
prog=/usr/local/bin/script.sh
[ -f /etc/script.conf ] || exit 1
RETVAL=0
start()
{
# Quit if disabled
if ! $ENABLED; then
echo "Service Disabled in /etc/default/script"
exit 1
fi
echo "Starting $prog"
daemon $prog
RETVAL=$?
return $RETVAL
}
stop ()
{
echo -n $"Stopping $prog: "
killproc $prog
RETVAL=$?
return $RETVAL
}
reload()
{
echo "Reload command is not implemented for this service."
return $RETVAL
}
restart()
{
stop
start
}
condrestart()
{
echo "Not Implemented."
}
# See how we were called.
case "$1" in
start)
start
;;
stop)
stop
;;
status)
status $prog
;;
restart)
restart
;;
reload)
reload
;;
condrestart)
condrestart
;;
*)
echo $"Usage: $0 {start|stop|status|restart|condrestart|reload}"
RETVAL=1
esac
bash -vx를 사용하여 마지막 20줄 정도를 실행합니다.
+ case "$1" in
+ start
+ true
+ echo 'Starting /usr/local/bin/script.sh'
Starting /usr/local/bin/script.sh
+ daemon /usr/local/bin/script.sh
+ local gotbase= force=
+ local base= user= nice= bg= pid=
+ nicelevel=0
+ '[' /usr/local/bin/script.sh '!=' /usr/local/bin/script.sh ']'
+ '[' -z '' ']'
+ base=script.sh
+ '[' -f /var/run/script.sh.pid ']'
+ '[' -n '' -a -z '' ']'
+ ulimit -S -c 0
+ '[' -n '' ']'
+ '[' color = verbose -a -z '' ']'
+ '[' -z '' ']'
+ initlog -q -c /usr/local/bin/script.sh
답변1
에서 스크립트를 찾았습니다.http://www.linuxforums.org/forum/programming-scripting/190279-daemon-etc-init-d-functions-does-not-return-launching-process.html#post897522내 필요에 맞게 수정할 수 있습니다. PID를 수동으로 추적해서 사용했는데 , 스크립트의 PID를 볼 방법이 없었기 때문에 pidof
결국 수정해서 사용하게 되었습니다 . 수정 후 효과가 매우 좋습니다. *참고: pgrep은 전체 스크립트 이름이 15자 미만인 경우에만 작동하는 것 같습니다.pgrep
pidof
이것이 내가 끝내는 것입니다 :
#!/bin/bash
#
#
#
# Start on runlevels 3, 4 and 5. Start late, kill early.
# chkconfig: 345 95 05
#
#
#!/bin/bash
# absolute path to executable binary
progpath='/usr/local/bin/script.sh'
# arguments to script
opts=''
# binary program name
prog=$(basename $progpath)
# pid file
pidfile="/var/run/${prog}.pid"
# make sure full path to executable binary is found
! [ -x $progpath ] && echo "$progpath: executable not found" && exit 1
eval_cmd() {
local rc=$1
if [ $rc -eq 0 ]; then
echo '[ OK ]'
else
echo '[FAILED]'
fi
return $rc
}
start() {
# see if running
local pids=$(pgrep $prog)
if [ -n "$pids" ]; then
echo "$prog (pid $pids) is already running"
return 0
fi
printf "%-50s%s" "Starting $prog: " ''
$progpath $opts &
# save pid to file if you want
echo $! > $pidfile
# check again if running
pgrep $prog >/dev/null 2>&1
eval_cmd $?
}
stop() {
# see if running
local pids=$(pgrep $prog)
if [ -z "$pids" ]; then
echo "$prog not running"
return 0
fi
printf "%-50s%s" "Stopping $prog: " ''
rm -f $pidfile
kill -9 $pids
eval_cmd $?
}
status() {
# see if running
local pids=$(pgrep $prog)
if [ -n "$pids" ]; then
echo "$prog (pid $pids) is running"
else
echo "$prog is stopped"
fi
}
case $1 in
start)
start
;;
stop)
stop
;;
status)
status
;;
restart)
stop
sleep 1
start
;;
*)
echo "Usage: $0 {start|stop|status|restart}"
exit 1
esac
exit $?
답변2
저는 Redhat에 대해 잘 모르지만 daemon $prog &
제가 보기에는 이상해 보입니다. 데몬에 대한 기능이 이미 있는 경우 이 기능 자체를 백그라운드에 배치하는 것이 왜 필요하고 유용합니까? 그러므로 그것을 사용하지 마십시오 &
.